Summary: Squid usage report generator per user/ip/name
Name: sarg
Version: 2.2.5
Release: 1.endian1
License: GPL
Group: Applications/Internet
URL: http://sarg.sourceforge.net/sarg.php
Source: http://dl.sf.net/sarg/sarg-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: perl, gd-devel >= 1.8
Requires: bash, squid, gd >= 1.8

%description
Squid Analysis Report Generator is a tool that allows you to view "where"
your users are going to on the Internet. Sarg generate reports in html
showing users, IP addresses, bytes, sites and times.

%prep
%setup

#%{__chmod} u+wx sarg-php/locale/

%{__perl} -pi.orig -e '
		s|^#(access_log) (.+)$|#$1 $2\n$1 /var/log/squid/access.log|;
		s|^#(output_dir) (.+)$|#$1 $2\n$1 /home/httpd/html/sarg/ONE-SHOT|;
		s|^#(resolve_ip) (.+)$|#$1 $2\n$1 yes|;
		s|^#(show_successful_message) (.+)$|#$1 $2\n$1 no|;
		s|^#(mail_utility) (.+)$|#$1 $2\n$1 mail|;
		s|^#(external_css_file) (.+)$|#$1 $2\n$1 /home/httpd/html/sarg/sarg.css|;
		s|^#(dansguardian_conf) (.+)$|#$1 $2\n$1 /etc/dansguardian/dansguardian.conf|; 
		s|^#(dansguardian_ignore_date) (.+)$|#$1 $2\n$1 on|; 
	' sarg.conf

%{__cat} <<'EOF' >sarg.daily
#!/bin/bash

# Get yesterday's date
YESTERDAY=$(date --date "1 days ago" +%d/%m/%Y)

exec /usr/bin/sarg \
	-o /home/httpd/html/sarg/daily \
	-d $YESTERDAY &>/dev/null
exit 0
EOF

%{__cat} <<'EOF' >sarg.weekly
#!/bin/bash
LOG_FILES=
if [ -s /var/log/squid/access.log.1.gz ]; then
	LOG_FILES="$LOG_FILES -l /var/log/squid/access.log.1.gz"
fi
if [ -s /var/log/squid/access.log ]; then
	LOG_FILES="$LOG_FILES -l /var/log/squid/access.log"
fi

# Get yesterday's date
YESTERDAY=$(date --date "1 days ago" +%d/%m/%Y)

# Get one week ago date
WEEKAGO=$(date --date "7 days ago" +%d/%m/%Y)

exec /usr/bin/sarg \
	$LOG_FILES \
	-o /home/httpd/html/sarg/weekly \
	-d $WEEKAGO-$YESTERDAY &>/dev/null
exit 0
EOF

%{__cat} <<'EOF' >sarg.monthly
#!/bin/bash
LOG_FILES=
if [ -s /var/log/squid/access.log.4.gz ]; then
	LOG_FILES="$LOG_FILES -l /var/log/squid/access.log.4.gz"
fi
if [ -s /var/log/squid/access.log.3.gz ]; then
	LOG_FILES="$LOG_FILES -l %{_localstatedir}/log/squid/access.log.3.gz"
fi
if [ -s %{_localstatedir}/log/squid/access.log.2.gz ]; then
	LOG_FILES="$LOG_FILES -l %{_localstatedir}/log/squid/access.log.2.gz"
fi
if [ -s %{_localstatedir}/log/squid/access.log.1.gz ]; then
	LOG_FILES="$LOG_FILES -l %{_localstatedir}/log/squid/access.log.1.gz"
fi
if [ -s %{_localstatedir}/log/squid/access.log ]]; then
	LOG_FILES="$LOG_FILES -l %{_localstatedir}/log/squid/access.log"
fi

# Get yesterday's date
YESTERDAY=$(date --date "1 day ago" +%d/%m/%Y)

# Get 1 month ago date
MONTHAGO=$(date --date "1 month ago" +%d/%m/%Y)

exec /usr/bin/sarg \
	$LOG_FILES \
	-o /home/httpd/html/sarg/monthly \
	-d $MONTHAGO-$YESTERDAY &>/dev/null
exit 0
EOF

%{__cat} <<EOF >sarg-index.html
<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
	<title>Squid User's Access Report</title>
	<style type="text/css">
		#content         { width:20em; margin-left:auto; margin-right:auto; }
		h1               { color:green; font-size:1.2em; text-align:center; }
		table#reports    { border-collapse:collapse; width:20em; margin-left:auto; margin-right:auto; font-size:0.8em; }
		table#reports td { padding:2px; background-color:#f5f5dc; border:solid white 1px; }
		table#reports th { background-color:#feebcd; border:solid white 1px; color:#00008b; }
	</style>
</head>
<body>

<div id="content">
	<h1>Squid User's Access Report</h1>

	<table summary="" id="reports">
	<tbody>
	<tr>
		<th>DIRECTORY</th>
		<th>DESCRIPTION</th>
	</tr>
	<tr>
		<td><a href="ONE-SHOT/index.html">ONE-SHOT</a></td>
		<td>One shot reports</td>
	</tr>
	<tr>
		<td><a href="daily/index.html">daily</a></td>
		<td>Daily reports</td>
	</tr>
	<tr>
		<td><a href="weekly/index.html">weekly</a></td>
		<td>Weekly reports</td>
	</tr>
	<tr>
		<td><a href="monthly/index.html">monthly</a></td>
		<td>Monthly reports</td>
	</tr>
	</tbody>
	</table>
</div>
</body>
</html>
EOF

%build
%configure \
	--enable-bindir=/usr/bin \
	--enable-sysconfdir=/etc/sarg \
	--enable-mandir=/usr/man/man1 \
	--enable-htmldir=/home/httpd/html/sarg

%{__make} %{?_smp_mflags}

%install
%{__rm} -rf %{buildroot}
%{__install} -Dp -m0755 sarg %{buildroot}/usr/bin/sarg
%{__install} -Dp -m0644 sarg.conf %{buildroot}/etc/sarg/sarg.conf
%{__install} -Dp -m0644 exclude_codes %{buildroot}/etc/sarg/exclude_codes
%{__install} -Dp -m0644 sarg.1 %{buildroot}/usr/man/man1/sarg.1

%{__install} -Dp -m0755 sarg.daily %{buildroot}/etc/cron.daily/sarg
%{__install} -Dp -m0755 sarg.weekly %{buildroot}/etc/cron.weekly/sarg
%{__install} -Dp -m0755 sarg.monthly %{buildroot}/etc/cron.monthly/sarg
%{__install} -Dp -m0644 sarg-index.html %{buildroot}/home/httpd/html/sarg/index.html
%{__install} -Dp -m0644 css.tpl %{buildroot}/home/httpd/html/sarg/sarg.css

%{__install} -d -m0755 %{buildroot}/home/httpd/html/sarg/{ONE-SHOT,daily,weekly,monthly}/
%{__cp} -av fonts/ images/ languages/ %{buildroot}/etc/sarg/

### Clean up buildroot
%{__rm} -rf %{buildroot}/etc/sarg/languages/.new

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-, root, root, 0755)
%doc ChangeLog CONTRIBUTORS COPYING DONATIONS README
%doc /usr/man/man1/sarg.1*
%dir /etc/sarg/
%config /etc/sarg/exclude_codes
%config(noreplace) /etc/sarg/sarg.conf
%config /etc/cron.daily/sarg
%config /etc/cron.weekly/sarg
%config /etc/cron.monthly/sarg
/usr/bin/sarg
/home/httpd/html/sarg/
/etc/sarg/fonts/
/etc/sarg/images/
/etc/sarg/languages/

%changelog
* Fri Apr 04 2008 Mike Tremaine <mgt@stellarcore.net> - 2.2.5-1
- Updates for 2.2.5 added dansguardian_conf and ignore_date on
* Mon Jun 12 2007 Mike Tremaine <mgt@stellarcore.net> - 2.2.1-1
- Inital Spec for release 2.2.1.
